﻿-- ** Meliandah / Animal Species / 20.02.2019  ** --
-- Version : 1.2
-- Last Changes : Price scaled and name harmonized.
 
animalSpecies = {}

function animalSpecies:debug(message)
  print(('### Animal Species : %s'):format(message));
end;

function animalSpecies:rpad(str, len, char)
    if len == nil then len = 15 end
    if char == nil then char = ' ' end
    return animalSpecies:ternary(str ~= nil, string.rep(char, len - #tostring(str)) .. tostring(str), string.rep(char, len));
end
function animalSpecies:lpad(str, len, char)
    if len == nil then len = 15 end
    if char == nil then char = ' ' end
    return animalSpecies:ternary(str ~= nil, tostring(str) .. string.rep(char, len - #tostring(str)), string.rep(char, len));
end
function animalSpecies:ternary(cond, T, F)
    if cond then return T else return F end
end

function animalSpecies:printAnimalTypes()
  --animalSpecies:debug('printing AnimalManager');
  --DebugUtil.printTableRecursively(g_currentMission.inGameMenu.pageAnimals.animalManager, ".", 0, 5);
  --animalSpecies:debug('printing animalTypes');
  --DebugUtil.printTableRecursively(g_currentMission.inGameMenu.pageAnimals.animalManager.animals, ".", 0, 10);

  animalSpecies:debug(('%s | %s | %s | %s | %s | %s | %s | %s | %s | %s')
    :format(animalSpecies:rpad('type'), animalSpecies:rpad('subTypeName', 25), animalSpecies:rpad('strawPerDay'), animalSpecies:rpad('waterPerDay'),  animalSpecies:rpad('foodPerDay'), 
            animalSpecies:rpad('manurePerDay'), animalSpecies:rpad('liquidManurePerDay'), animalSpecies:rpad('milkPerDay'), animalSpecies:rpad('palletsPerDay'), animalSpecies:rpad('birthRatePerDay', 20)));

  for k,v in pairs(g_currentMission.inGameMenu.pageAnimals.animalManager.animals) do
      --DebugUtil.printTableRecursively(v, ".", 0, 10);
	  for sk,sv in pairs(v.subTypes) do
      animalSpecies:debug(('%s | %s | %s | %s | %s | %s | %s | %s | %s | %s')
        :format(animalSpecies:rpad(v.class), animalSpecies:rpad(sv.subTypeName, 25), animalSpecies:rpad(sv.input.strawPerDay), animalSpecies:rpad(sv.input.waterPerDay),  animalSpecies:rpad(sv.input.foodPerDay), 
                animalSpecies:rpad(sv.output.manurePerDay), animalSpecies:rpad(sv.output.liquidManurePerDay), animalSpecies:rpad(sv.output.milkPerDay), animalSpecies:rpad(sv.output.palletsPerDay), animalSpecies:rpad(sv.breeding.birthRatePerDay, 20)));
	end;
  end;
end;

function animalSpecies:updateAnimalTypes()

  for k,v in pairs(g_currentMission.inGameMenu.pageAnimals.animalManager.animals) do
      --DebugUtil.printTableRecursively(v, ".", 0, 10);
	  for sk,sv in pairs(v.subTypes) do

      -- COWS ------------------------------------------------------------
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BROWN' then
        --KEEP NEUTRAL
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BROWN_WHITE' then
                sv.output.milkPerDay = sv.output.milkPerDay * 1.5;
                sv.output.manurePerDay = sv.output.manurePerDay * 2.5;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 2.5;
                sv.input.foodPerDay = sv.input.foodPerDay * 1.5;
                sv.input.waterPerDay = sv.input.waterPerDay * 1.5;
                sv.input.strawPerDay = sv.input.strawPerDay * 2.0;
                sv.storeInfo.buyPrice = 5000.0;
                sv.storeInfo.sellPrice = 2450.0;
                sv.storeInfo.transportPrice = 1500.0;
                sv.storeInfo.shopItemName = ('%s - x2: manure+(2.5)/milk-(1.5)'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.9;
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BLACK' then
                sv.output.milkPerDay = sv.output.milkPerDay * 2.5;
                sv.output.manurePerDay = sv.output.manurePerDay * 1.5;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 1.5;
                sv.input.foodPerDay = sv.input.foodPerDay * 2.5;
                sv.input.waterPerDay = sv.input.waterPerDay * 2.5;
                sv.input.strawPerDay = sv.input.strawPerDay * 2.0;
                sv.storeInfo.buyPrice = 5000.0;
                sv.storeInfo.sellPrice = 2450.0;
                sv.storeInfo.transportPrice = 1500.0;
                sv.storeInfo.shopItemName = ('%s - x2: manure-(1.5)/milk+(2.5)'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.9;          
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BLACK_WHITE' then
                sv.output.milkPerDay = sv.output.milkPerDay * 4.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 6.5;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 6.5;
                sv.input.foodPerDay = sv.input.foodPerDay * 5.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 5.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 5.0;
                sv.storeInfo.buyPrice = 13000.0;
                sv.storeInfo.sellPrice = 6000.0;
                sv.storeInfo.transportPrice = 4000.0;
                sv.storeInfo.shopItemName = ('%s - x5: manure+(6.5)/milk-(4)'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.75;       
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BRAHMAN_BROWN' then
                sv.output.milkPerDay = sv.output.milkPerDay * 6.5;
                sv.output.manurePerDay = sv.output.manurePerDay * 4.0;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 4.0;
                sv.input.foodPerDay = sv.input.foodPerDay * 5.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 5.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 5.0;
                sv.storeInfo.buyPrice = 13000.0;
                sv.storeInfo.sellPrice = 6000.0;
                sv.storeInfo.transportPrice = 4000.0;
                sv.storeInfo.shopItemName = ('%s - x5: manure-(4)/milk+(6.5)'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.75;    
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BRAHMAN_WHITE' then
                sv.output.milkPerDay = sv.output.milkPerDay * 10.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 10.0;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 10.0;
                sv.input.foodPerDay = sv.input.foodPerDay * 10.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 10.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 10.0;           
                sv.storeInfo.buyPrice = 27500.0;
                sv.storeInfo.sellPrice = 12500.0;
                sv.storeInfo.transportPrice = 10000.0;
                sv.storeInfo.shopItemName = ('%s - x10'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.5;
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BRAHMAN_LIGHT_BROWN' then
                sv.output.milkPerDay = sv.output.milkPerDay * 50.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 50.0;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 50.0;
                sv.input.foodPerDay = sv.input.foodPerDay * 50.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 50.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 50.0;
                sv.storeInfo.buyPrice = 130000.0;
                sv.storeInfo.sellPrice = 55000.0;
                sv.storeInfo.transportPrice = 40000.0;
                sv.storeInfo.shopItemName = ('%s - x50'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.35;
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BRAHMAN_GREY' then
                sv.output.milkPerDay = sv.output.milkPerDay * 100.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 100.0;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 100.0;
                sv.input.foodPerDay = sv.input.foodPerDay * 100.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 100.0; 
                sv.input.strawPerDay = sv.input.strawPerDay * 100.0;
                sv.storeInfo.shopItemName = ('%s - x100'):format(sv.storeInfo.shopItemName);             
                sv.storeInfo.buyPrice = 275000.0;
                sv.storeInfo.transportPrice = 100000.0;
                sv.storeInfo.sellPrice = 135000.0;
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.25;
      end;
      
      -- HORSES ---------------------------------------------------------
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_BROWN' then
                --KEEP NEUTRAL                
      end;
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_DARK_BROWN' then
                sv.input.foodPerDay = sv.input.foodPerDay * 2.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 2.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 2.0;
                sv.storeInfo.buyPrice = 10000.0;
                sv.storeInfo.transportPrice = 5000.0;
                sv.storeInfo.sellPrice = 100000.0;
                sv.storeInfo.shopItemName = ('%s - x2'):format(sv.storeInfo.shopItemName);     
      end;
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_BROWN_WHITE' then
                sv.input.foodPerDay = sv.input.foodPerDay * 5.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 5.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 5.0;
                sv.storeInfo.buyPrice = 30000.0;
                sv.storeInfo.transportPrice = 10000.0;
                sv.storeInfo.sellPrice = 225000.0;
                sv.storeInfo.shopItemName = ('%s - x5'):format(sv.storeInfo.shopItemName);               
      end;
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_GREY' then
                sv.input.foodPerDay = sv.input.foodPerDay * 10.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 10.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 10.0;
                sv.storeInfo.buyPrice = 60000.0;
                sv.storeInfo.transportPrice = 17500.0;
                sv.storeInfo.sellPrice = 450000.0;
                sv.storeInfo.shopItemName = ('%s - x10'):format(sv.storeInfo.shopItemName);              
      end;
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_LIGHT_BROWN' then
                sv.input.foodPerDay = sv.input.foodPerDay * 25.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 25.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 25.0;
                sv.storeInfo.buyPrice = 130000.0;
                sv.storeInfo.transportPrice = 50000.0;
                sv.storeInfo.sellPrice = 1100000.0;   
                sv.storeInfo.shopItemName = ('%s - x25'):format(sv.storeInfo.shopItemName);            
      end;
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_BEIGE' then
                sv.input.foodPerDay = sv.input.foodPerDay * 50.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 50.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 50.0;
                sv.storeInfo.buyPrice = 275000.0;
                sv.storeInfo.transportPrice = 95000.0;
                sv.storeInfo.sellPrice = 2250000.0;
                sv.storeInfo.shopItemName = ('%s - x50'):format(sv.storeInfo.shopItemName);
      end;
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_RED_BROWN' then
                sv.input.foodPerDay = sv.input.foodPerDay * 100.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 100.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 100.0;
                sv.storeInfo.buyPrice = 550000.0;
                sv.storeInfo.transportPrice = 190000.0;
                sv.storeInfo.sellPrice = 4500000.0;
                sv.storeInfo.shopItemName = ('%s - x100'):format(sv.storeInfo.shopItemName);               
      end;
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_BLACK' then
                sv.input.foodPerDay = sv.input.foodPerDay * 250.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 250.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 250.0;
                sv.storeInfo.buyPrice = 1200000.0;
                sv.storeInfo.transportPrice = 375000.0;
                sv.storeInfo.sellPrice = 10000000.0;                
                sv.storeInfo.shopItemName = ('%s - x250'):format(sv.storeInfo.shopItemName);
      end;
      
      -- SHEEP ---------------------------------------------------------
      
      if sv.fillTypeDesc.name == 'SHEEP_TYPE_WHITE' then                                
             -- KEEP NEUTRAL        
      end;
      
      if sv.fillTypeDesc.name == 'SHEEP_TYPE_BROWN' then
                sv.input.foodPerDay = sv.input.foodPerDay * 5.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 5.0;
                sv.output.palletsPerDay = sv.output.palletsPerDay * 5.0;               
                sv.storeInfo.buyPrice = 7750.0;
                sv.storeInfo.transportPrice = 2500.0;
                sv.storeInfo.sellPrice = 3500.0;                
                sv.storeInfo.shopItemName = ('%s - x5'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.75;
      end;
      
      if sv.fillTypeDesc.name == 'SHEEP_TYPE_BLACK_WHITE' then
                sv.input.foodPerDay = sv.input.foodPerDay * 10.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 10.0;
                sv.output.palletsPerDay = sv.output.palletsPerDay * 10.0;            
                sv.storeInfo.buyPrice = 16000.0;
                sv.storeInfo.transportPrice = 5500.0;
                sv.storeInfo.sellPrice = 7500.0;                
                sv.storeInfo.shopItemName = ('%s - x10'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.5;
      end;
      
      if sv.fillTypeDesc.name == 'SHEEP_TYPE_BLACK' then
                sv.input.foodPerDay = sv.input.foodPerDay * 100.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 100.0;
                sv.output.palletsPerDay = sv.output.palletsPerDay * 100.0;              
                sv.storeInfo.buyPrice = 165000.0;
                sv.storeInfo.transportPrice = 50000.0;
                sv.storeInfo.sellPrice = 75000.0;                
                sv.storeInfo.shopItemName = ('%s - x100'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.25;
      end;
      
      
      -- CHICKEN ---------------------------------------------------------
      
      if sv.fillTypeDesc.name == 'CHICKEN_TYPE_WHITE' then               
               --KEEP NEUTRAL
      end;
      
      if sv.fillTypeDesc.name == 'CHICKEN_TYPE_ROOSTER' then               
               --KEEP NEUTRAL
      end;
      
      if sv.fillTypeDesc.name == 'CHICKEN_TYPE_BLACK' then
                sv.input.foodPerDay = sv.input.foodPerDay * 10.0;                
                sv.output.palletsPerDay = sv.output.palletsPerDay * 10.0;               
                sv.storeInfo.buyPrice = 500.0;
                sv.storeInfo.transportPrice = 50.0;
                sv.storeInfo.sellPrice = 240.0;
                sv.storeInfo.shopItemName = ('%s - x10'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.5; 
      end;
      
      if sv.fillTypeDesc.name == 'CHICKEN_TYPE_BROWN' then
                sv.input.foodPerDay = sv.input.foodPerDay * 100.0;
                sv.output.palletsPerDay = sv.output.palletsPerDay * 100.0;               
                sv.storeInfo.buyPrice = 5500.0;
                sv.storeInfo.transportPrice = 150.0;
                sv.storeInfo.sellPrice = 2500.0;                
                sv.storeInfo.shopItemName = ('%s - x100'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.25;
      end;
      
      -- PIG ---------------------------------------------------------
      
      if sv.fillTypeDesc.name == 'PIG_TYPE_RED' then                                
                --KEEP NEUTRAL        
      end;
      
      if sv.fillTypeDesc.name == 'PIG_TYPE_WHITE' then
                sv.input.foodPerDay = sv.input.foodPerDay * 5.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 5.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 10.00;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 10.00;
                sv.input.strawPerDay = sv.input.strawPerDay * 5.0;         
                sv.storeInfo.buyPrice = 7500.0;
                sv.storeInfo.transportPrice = 2250.0;
                sv.storeInfo.sellPrice = 3000.0;                
                sv.storeInfo.shopItemName = ('%s - x5'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.75;    
      end;
      
      if sv.fillTypeDesc.name == 'PIG_TYPE_BLACK_WHITE' then
                sv.input.foodPerDay = sv.input.foodPerDay * 10.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 10.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 20.00;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 20.00;
                sv.input.strawPerDay = sv.input.strawPerDay * 10.0;         
                sv.storeInfo.buyPrice = 16000.0;
                sv.storeInfo.transportPrice = 5000.0;
                sv.storeInfo.sellPrice = 7500.0;                
                sv.storeInfo.shopItemName = ('%s - x10'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.5;
      end;
      
      if sv.fillTypeDesc.name == 'PIG_TYPE_BLACK' then
                sv.input.foodPerDay = sv.input.foodPerDay * 100.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 100.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 200.00;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 200.00;
                sv.input.strawPerDay = sv.input.strawPerDay * 100.0;             
                sv.storeInfo.buyPrice = 165000.0;
                sv.storeInfo.transportPrice = 50000.0;
                sv.storeInfo.sellPrice = 75000.0;                
                sv.storeInfo.shopItemName = ('%s - x100'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.25;
      end;
    end;
  end;
end;

function animalSpecies:loadMap(name)    
    animalSpecies:updateAnimalTypes();
    animalSpecies:printAnimalTypes();
end;

function animalSpecies:keyEvent(unicode, sym, modifier, isDown)
end;

function animalSpecies:update(dt)
end;

function animalSpecies:draw()
end;

function animalSpecies:deleteMap()
end;

function animalSpecies:mouseEvent(posX, posY, isDown, isUp, button)
end;

addModEventListener(animalSpecies);